/*
 * Copyright © 2006, DoCoMo Communications Laboratories USA, Inc.,
 *   the DoCoMo SEND Project
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of DoCoMo Communications Laboratories USA, Inc., its
 *    parents, affiliates, subsidiaries, theDoCoMo SEND Project nor the names
 *    of the Project's contributors may be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY THE PROJECT AND CONTRIBUTORS ``AS IS'' AND
 *  ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 *  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 *  ARE DISCLAIMED. IN NO EVENT SHALL DOCOMO COMMUNICATIONS LABORATORIES USA,
 *  INC., ITS PARENTS, AFFILIATES, SUBSIDIARIES, THE PROJECT OR THE PROJECT'S
 *  CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 *  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 *  PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 *  OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 *  WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 *  OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
 *  ADVISED OF THE POSSIBILITY OF SUCH DAMAGE."
 */

#ifndef	_OS_SPECIFIC_H
#define	_OS_SPECIFIC_H

#include <netinet/in.h>
#include <sbuff.h>

extern void snd_recv_pkt(struct sbuff *, int, int, void *);

extern int os_specific_add_addr(struct in6_addr *, int, int, uint32_t,
    uint32_t);
extern void os_specific_add_fds(fd_set *, int *);
extern int os_specific_del_addr(struct in6_addr *, int, int);
extern void os_specific_deliver_pkt(void *, struct sbuff *, int, int);
extern void os_specific_dispatch_fds(fd_set *);
extern int os_specific_get_rand_bytes(void *, int);
extern int os_specific_handle_iface(const char *, int);
extern void os_specific_fini(void);
extern int os_specific_init(void);

extern void snd_add_fds(fd_set *, int *, int);
extern void snd_dispatch_fds(fd_set *);
extern int snd_handle_iface(const char *, int);

static __inline__ int
sendd_max(int a, int b)
{
	return (a > b ? a : b);
}

#endif	/* _OS_SPECIFIC_H */
